Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::Hex_Decoder Class Referencefinal

`#include <hex_filt.h>`

Inheritance diagram for Botan::Hex_Decoder:

## Public Member Functions
virtual bool | attachable ()
void | end_msg () override
| Hex_Decoder (Decoder_Checking checking=NONE)
std::string | name () const override
virtual void | start_msg ()
void | write (const uint8_t[], size_t) override

## Protected Member Functions
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
void | send (const secure_vector< uint8_t > &in)
void | send (const std::vector< uint8_t > &in)
void | send (const secure_vector< uint8_t > &in, size_t length)
void | send (const std::vector< uint8_t > &in, size_t length)

## Detailed Description

Converts hex strings to bytes

Definition at line 59 of file hex_filt.h.

## Constructor & Destructor Documentation

Botan::Hex_Decoder::Hex_Decoder | ( | Decoder_Checking | checking = `NONE` | ) |
| explicit

Construct a Hex Decoder using the specified character checking.

Parameters

  checking | the checking to use during decoding.

Definition at line 110 of file hex_filt.cpp.

110 : m_checking(c)
111 {
112 m_in.resize(HEX_CODEC_BUFFER_SIZE);
113 m_out.resize(m_in.size() / 2);
114 m_position = 0;
115 }
Botan::HEX_CODEC_BUFFER_SIZE
const size_t HEX_CODEC_BUFFER_SIZE
Definition: hex_filt.cpp:20

## Member Function Documentation

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 52 of file filter.h.

52 { return true; }

void Botan::Hex_Decoder::end_msg | ( |  | ) |
| override virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 153 of file hex_filt.cpp.

References Botan::FULL_CHECK, Botan::hex_decode(), and Botan::Filter::send().

154 {
155 size_t consumed = 0;
156 size_t written = hex_decode(m_out.data(),
157 reinterpret_cast<const char*>(m_in.data()),
158 m_position,
159 consumed,
160 m_checking != FULL_CHECK);
161
162 send(m_out, written);
163
164 const bool not_full_bytes = consumed != m_position;
165
166 m_position = 0;
167
168 if(not_full_bytes)
169 throw Invalid_Argument("Hex_Decoder: Input not full bytes");
170 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27
Botan::FULL_CHECK
Definition: filter.h:179
Botan::hex_decode
size_t hex_decode(uint8_t output[], const char input[], size_t input_length, size_t &input_consumed, bool ignore_ws)
Definition: hex.cpp:49

std::string Botan::Hex_Decoder::name | ( |  | ) | const
| inline override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 62 of file hex_filt.h.

62 { return "Hex_Decoder"; }

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

References Botan::Filter::write().

Referenced by Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), end_msg(), Botan::Base64_Decoder::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::StreamCipher_Filter::write(), write(), and Botan::Base64_Decoder::write().

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

65 { send(&in, 1); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 70 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

70 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 75 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

75 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 send(in.data(), length);
84 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 90 of file filter.h.

91 {
92 send(in.data(), length);
93 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40 {}

void Botan::Hex_Decoder::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| override virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 120 of file hex_filt.cpp.

References Botan::copy_mem(), Botan::FULL_CHECK, Botan::hex_decode(), and Botan::Filter::send().

121 {
122 while(length)
123 {
124 size_t to_copy = std::min<size_t>(length, m_in.size() - m_position);
125 copy_mem(&m_in[m_position], input, to_copy);
126 m_position += to_copy;
127
128 size_t consumed = 0;
129 size_t written = hex_decode(m_out.data(),
130 reinterpret_cast<const char*>(m_in.data()),
131 m_position,
132 consumed,
133 m_checking != FULL_CHECK);
134
135 send(m_out, written);
136
137 if(consumed != m_position)
138 {
139 copy_mem(m_in.data(), m_in.data() + consumed, m_position - consumed);
140 m_position = m_position - consumed;
141 }
142 else
143 m_position = 0;
144
145 length -= to_copy;
146 input += to_copy;
147 }
148 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27
Botan::FULL_CHECK
Definition: filter.h:179
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:68
Botan::hex_decode
size_t hex_decode(uint8_t output[], const char input[], size_t input_length, size_t &input_consumed, bool ignore_ws)
Definition: hex.cpp:49

The documentation for this class was generated from the following files:

- src/lib/filters/codec_filt/hex_filt.h
- src/lib/filters/codec_filt/hex_filt.cpp